// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 36 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"

  /// Build a parser object.
  Parser::Parser (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.YY_MOVE_OR_COPY< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.YY_MOVE_OR_COPY< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.YY_MOVE_OR_COPY< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.YY_MOVE_OR_COPY< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog: // subprog
        value.YY_MOVE_OR_COPY< ast::Subprog * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.YY_MOVE_OR_COPY< ast::SubprogArg * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.YY_MOVE_OR_COPY< ast::SubprogArgList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.YY_MOVE_OR_COPY< std::pair<ast::ProbeList *, ast::SubprogList *> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog: // subprog
        value.move< ast::Subprog * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.move< ast::SubprogArg * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.move< ast::SubprogArgList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.move< std::pair<ast::ProbeList *, ast::SubprogList *> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.copy< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.copy< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.copy< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.copy< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_subprog: // subprog
        value.copy< ast::Subprog * > (that.value);
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.copy< ast::SubprogArg * > (that.value);
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.copy< ast::SubprogArgList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.copy< std::pair<ast::ProbeList *, ast::SubprogList *> > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_config: // config
        value.move< ast::Config * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_subprog: // subprog
        value.move< ast::Subprog * > (that.value);
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        value.move< ast::SubprogArg * > (that.value);
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        value.move< ast::SubprogArgList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        value.move< std::pair<ast::ProbeList *, ast::SubprogList *> > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        yylhs.value.emplace< SizedType > ();
        break;

      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_config: // config
        yylhs.value.emplace< ast::Config * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        yylhs.value.emplace< ast::Offsetof * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        yylhs.value.emplace< ast::Sizeof * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_for_stmt: // for_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_config_assign_stmt: // config_assign_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_config_block: // config_block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_config_assign_stmt_list: // config_assign_stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_subprog: // subprog
        yylhs.value.emplace< ast::Subprog * > ();
        break;

      case symbol_kind::S_subprog_arg: // subprog_arg
        yylhs.value.emplace< ast::SubprogArg * > ();
        break;

      case symbol_kind::S_subprog_args: // subprog_args
        yylhs.value.emplace< ast::SubprogArgList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_probes_and_subprogs: // probes_and_subprogs
        yylhs.value.emplace< std::pair<ast::ProbeList *, ast::SubprogList *> > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SUBPROG: // "subprog"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_CONFIG: // "config"
      case symbol_kind::S_UNROLL: // "unroll"
      case symbol_kind::S_WHILE: // "while"
      case symbol_kind::S_FOR: // "for"
      case symbol_kind::S_RETURN: // "return"
      case symbol_kind::S_IF: // "if"
      case symbol_kind::S_ELSE: // "else"
      case symbol_kind::S_CONTINUE: // "continue"
      case symbol_kind::S_BREAK: // "break"
      case symbol_kind::S_SIZEOF: // "sizeof"
      case symbol_kind::S_OFFSETOF: // "offsetof"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_keyword: // keyword
      case symbol_kind::S_ident: // ident
      case symbol_kind::S_external_name: // external_name
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions config probes_and_subprogs "end of file"
#line 179 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                             {
                    driver.root = std::make_unique<ast::Program>(yystack_[3].value.as < std::string > (), yystack_[2].value.as < ast::Config * > (), yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().second, yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().first);
                }
#line 1345 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 185 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1351 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct" "struct definition" c_definitions
#line 186 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1357 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 5: // c_definitions: "struct" "enum" c_definitions
#line 187 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1363 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 188 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::string(); }
#line 1369 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 7: // type: int_type
#line 192 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                         { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1375 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 8: // type: "builtin type"
#line 193 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"void", CreateVoid()},
                        {"min_t", CreateMin(true)},
                        {"max_t", CreateMax(true)},
                        {"sum_t", CreateSum(true)},
                        {"count_t", CreateCount(true)},
                        {"avg_t", CreateAvg(true)},
                        {"stats_t", CreateStats(true)},
                        {"umin_t", CreateMin(false)},
                        {"umax_t", CreateMax(false)},
                        {"usum_t", CreateSum(false)},
                        {"ucount_t", CreateCount(false)},
                        {"uavg_t", CreateAvg(false)},
                        {"ustats_t", CreateStats(false)},
                        {"timestamp_t", CreateTimestamp()},
                        {"macaddr_t", CreateMacAddress()},
                        {"cgroup_path_t", CreateCgroupPath()},
                        {"strerror_t", CreateStrerror()},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1402 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 9: // type: "sized type" "[" "integer" "]"
#line 215 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                       {
                    if (yystack_[3].value.as < std::string > () == "str_t") {
                        yylhs.value.as < SizedType > () = CreateString(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "inet_t") {
                        yylhs.value.as < SizedType > () = CreateInet(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "buf_t") {
                        yylhs.value.as < SizedType > () = CreateBuffer(yystack_[1].value.as < int64_t > ());
                    }
                }
#line 1416 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 10: // type: int_type "[" "integer" "]"
#line 224 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     {
                  yylhs.value.as < SizedType > () = CreateArray(yystack_[1].value.as < int64_t > (), yystack_[3].value.as < SizedType > ());
                }
#line 1424 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 11: // type: int_type "[" "]"
#line 227 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                 {
                  yylhs.value.as < SizedType > () = CreateArray(0, yystack_[2].value.as < SizedType > ());
                }
#line 1432 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 12: // type: pointer_type
#line 230 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1438 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 13: // type: struct_type
#line 231 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                            { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1444 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 14: // int_type: "integer type"
#line 235 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                         {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"bool", CreateBool()},
                        {"uint8", CreateUInt(8)},
                        {"uint16", CreateUInt(16)},
                        {"uint32", CreateUInt(32)},
                        {"uint64", CreateUInt(64)},
                        {"int8", CreateInt(8)},
                        {"int16", CreateInt(16)},
                        {"int32", CreateInt(32)},
                        {"int64", CreateInt(64)},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1463 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 15: // pointer_type: type "*"
#line 252 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                         { yylhs.value.as < SizedType > () = CreatePointer(yystack_[1].value.as < SizedType > ()); }
#line 1469 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 16: // struct_type: "struct" "identifier"
#line 255 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < SizedType > () = ast::ident_to_record(yystack_[0].value.as < std::string > ()); }
#line 1475 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 17: // config: "config" "=" config_block
#line 259 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = new ast::Config(yystack_[0].value.as < ast::StatementList * > ()); }
#line 1481 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 18: // config: %empty
#line 260 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Config * > () = nullptr; }
#line 1487 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 19: // subprog: "subprog" "identifier" "(" subprog_args ")" ":" type block
#line 264 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                                  {
                    yylhs.value.as < ast::Subprog * > () = new ast::Subprog(yystack_[6].value.as < std::string > (), yystack_[1].value.as < SizedType > (), yystack_[4].value.as < ast::SubprogArgList * > (), yystack_[0].value.as < ast::StatementList * > ());
                }
#line 1495 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 20: // subprog: "subprog" "identifier" "(" ")" ":" type block
#line 267 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     {
                    yylhs.value.as < ast::Subprog * > () = new ast::Subprog(yystack_[5].value.as < std::string > (), yystack_[1].value.as < SizedType > (), new ast::SubprogArgList, yystack_[0].value.as < ast::StatementList * > ());
                }
#line 1503 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 21: // subprog_args: subprog_args "," subprog_arg
#line 273 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yystack_[2].value.as < ast::SubprogArgList * > ()->push_back(yystack_[0].value.as < ast::SubprogArg * > ()); yylhs.value.as < ast::SubprogArgList * > () = yystack_[2].value.as < ast::SubprogArgList * > (); }
#line 1509 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 22: // subprog_args: subprog_arg
#line 274 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yylhs.value.as < ast::SubprogArgList * > () = new ast::SubprogArgList; yylhs.value.as < ast::SubprogArgList * > ()->push_back(yystack_[0].value.as < ast::SubprogArg * > ()); }
#line 1515 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 23: // subprog_arg: "variable" ":" type
#line 278 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::SubprogArg * > () = new ast::SubprogArg(yystack_[2].value.as < std::string > (), yystack_[0].value.as < SizedType > ()); }
#line 1521 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 24: // probes_and_subprogs: probes_and_subprogs probe
#line 282 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                            { yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > () = yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > (); yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().first->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1527 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 25: // probes_and_subprogs: probes_and_subprogs subprog
#line 283 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                            { yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > () = yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > (); yystack_[1].value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().second->push_back(yystack_[0].value.as < ast::Subprog * > ()); }
#line 1533 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 26: // probes_and_subprogs: probe
#line 284 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > () = { new ast::ProbeList, new ast::SubprogList}; yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().first->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1539 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 27: // probes_and_subprogs: subprog
#line 285 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > () = { new ast::ProbeList, new ast::SubprogList}; yylhs.value.as < std::pair<ast::ProbeList *, ast::SubprogList *> > ().second->push_back(yystack_[0].value.as < ast::Subprog * > ()); }
#line 1545 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 28: // probe: attach_points pred block
#line 290 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1559 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 29: // probe: attach_points "end of file"
#line 300 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1573 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 30: // attach_points: attach_points "," attach_point
#line 312 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1579 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 31: // attach_points: attach_point
#line 313 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1585 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 32: // attach_point: attach_point_def
#line 317 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1591 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 33: // attach_point_def: attach_point_def ident
#line 321 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1597 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 34: // attach_point_def: attach_point_def "string"
#line 325 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1603 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 35: // attach_point_def: attach_point_def "path"
#line 326 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1609 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 36: // attach_point_def: attach_point_def "integer"
#line 327 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < int64_t > ()); }
#line 1615 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 37: // attach_point_def: attach_point_def ":"
#line 328 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1621 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 38: // attach_point_def: attach_point_def "."
#line 329 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1627 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 39: // attach_point_def: attach_point_def "+"
#line 330 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1633 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 40: // attach_point_def: attach_point_def "*"
#line 331 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1639 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 41: // attach_point_def: attach_point_def "["
#line 332 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1645 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 42: // attach_point_def: attach_point_def "]"
#line 333 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1651 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 43: // attach_point_def: attach_point_def param
#line 335 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1668 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 44: // attach_point_def: %empty
#line 347 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1674 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 45: // pred: "/" expr "end predicate"
#line 351 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1680 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 46: // pred: %empty
#line 352 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1686 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 47: // param: "positional parameter"
#line 357 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1702 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 48: // param: "$#"
#line 368 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1708 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 49: // block: "{" stmt_list "}"
#line 372 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1714 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 50: // config_block: "{" config_assign_stmt_list "}"
#line 375 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                    { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1720 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 51: // stmt_list: expr_stmt ";" stmt_list
#line 382 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1726 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 52: // stmt_list: expr_stmt
#line 383 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1732 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 53: // stmt_list: block_stmt stmt_list
#line 387 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1738 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 54: // stmt_list: %empty
#line 388 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1744 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 55: // config_assign_stmt_list: config_assign_stmt ";" config_assign_stmt_list
#line 392 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1750 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 56: // config_assign_stmt_list: config_assign_stmt
#line 393 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1756 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 57: // config_assign_stmt_list: %empty
#line 394 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                               { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1762 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 58: // block_stmt: loop_stmt
#line 398 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1768 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 59: // block_stmt: if_stmt
#line 399 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1774 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 60: // block_stmt: for_stmt
#line 400 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1780 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 61: // expr_stmt: expr
#line 404 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1786 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 62: // expr_stmt: jump_stmt
#line 405 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1792 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 63: // expr_stmt: assign_stmt
#line 410 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1798 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 64: // jump_stmt: "break"
#line 414 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1804 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 65: // jump_stmt: "continue"
#line 415 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1810 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 66: // jump_stmt: "return"
#line 416 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1816 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 67: // jump_stmt: "return" expr
#line 417 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                            { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1822 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 68: // loop_stmt: "unroll" "(" int ")" block
#line 421 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1828 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 69: // loop_stmt: "unroll" "(" param ")" block
#line 422 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1834 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 70: // loop_stmt: "while" "(" expr ")" block
#line 423 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1840 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 71: // for_stmt: "for" "(" var ":" expr ")" block
#line 427 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::For(yystack_[4].value.as < ast::Variable * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[6].location); }
#line 1846 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 72: // if_stmt: "if" "(" expr ")" block
#line 431 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1852 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 73: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 432 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1858 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 74: // block_or_if: block
#line 436 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1864 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 75: // block_or_if: if_stmt
#line 437 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1870 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 76: // config_assign_stmt: "identifier" "=" expr
#line 441 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                    { yylhs.value.as < ast::Statement * > () = new ast::AssignConfigVarStatement(yystack_[2].value.as < std::string > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1876 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 77: // assign_stmt: tuple_access_expr "=" expr
#line 445 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1885 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 78: // assign_stmt: map "=" expr
#line 449 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yylhs.location); }
#line 1891 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 79: // assign_stmt: var "=" expr
#line 450 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yylhs.location); }
#line 1897 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 80: // assign_stmt: map compound_op expr
#line 452 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1906 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 81: // assign_stmt: var compound_op expr
#line 457 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1915 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 82: // primary_expr: "identifier"
#line 464 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1921 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 83: // primary_expr: int
#line 465 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1927 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 84: // primary_expr: "string"
#line 466 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1933 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 85: // primary_expr: "stack_mode"
#line 467 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1939 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 86: // primary_expr: "builtin"
#line 468 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1945 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 87: // primary_expr: "call_builtin"
#line 469 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1951 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 88: // primary_expr: "(" expr ")"
#line 470 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1957 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 89: // primary_expr: param
#line 471 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1963 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 90: // primary_expr: map_or_var
#line 472 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1969 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 91: // primary_expr: "(" expr "," vargs ")"
#line 474 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1980 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 92: // postfix_expr: primary_expr
#line 483 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1986 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 93: // postfix_expr: postfix_expr "." external_name
#line 485 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1992 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 94: // postfix_expr: postfix_expr "->" external_name
#line 486 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1998 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 95: // postfix_expr: tuple_access_expr
#line 488 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2004 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 96: // postfix_expr: postfix_expr "[" expr "]"
#line 490 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 2010 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 97: // postfix_expr: call
#line 491 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 2016 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 98: // postfix_expr: sizeof_expr
#line 492 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Sizeof * > (); }
#line 2022 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 99: // postfix_expr: offsetof_expr
#line 493 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Offsetof * > (); }
#line 2028 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 100: // postfix_expr: map_or_var "++"
#line 494 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 2034 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 101: // postfix_expr: map_or_var "--"
#line 495 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 2040 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 102: // postfix_expr: "++" ident
#line 497 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 2046 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 103: // postfix_expr: "--" ident
#line 498 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                               { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 2052 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 104: // tuple_access_expr: postfix_expr "." "integer"
#line 503 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < int64_t > (), yystack_[0].location); }
#line 2058 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 105: // unary_expr: unary_op cast_expr
#line 509 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2064 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 106: // unary_expr: postfix_expr
#line 510 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2070 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 107: // unary_expr: "++" map_or_var
#line 511 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2076 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 108: // unary_expr: "--" map_or_var
#line 512 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2082 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 109: // unary_expr: ident "--"
#line 514 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 2088 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 110: // unary_expr: ident "++"
#line 515 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 2094 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 111: // unary_op: "*"
#line 519 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2100 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 112: // unary_op: "~"
#line 520 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 2106 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 113: // unary_op: "!"
#line 521 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 2112 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 114: // unary_op: "-"
#line 522 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2118 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 115: // expr: conditional_expr
#line 526 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2124 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 116: // conditional_expr: logical_or_expr
#line 530 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2130 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 117: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 531 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 2136 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 118: // logical_or_expr: logical_and_expr
#line 536 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2142 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 119: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 537 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2148 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 120: // logical_and_expr: or_expr
#line 541 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2154 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 121: // logical_and_expr: logical_and_expr "&&" or_expr
#line 542 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2160 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 122: // or_expr: xor_expr
#line 546 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2166 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 123: // or_expr: or_expr "|" xor_expr
#line 547 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2172 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 124: // xor_expr: and_expr
#line 551 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2178 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 125: // xor_expr: xor_expr "^" and_expr
#line 552 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2184 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 126: // and_expr: equality_expr
#line 557 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2190 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 127: // and_expr: and_expr "&" equality_expr
#line 558 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2196 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 128: // equality_expr: relational_expr
#line 562 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2202 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 129: // equality_expr: equality_expr "==" relational_expr
#line 563 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2208 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 130: // equality_expr: equality_expr "!=" relational_expr
#line 564 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2214 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 131: // relational_expr: shift_expr
#line 568 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2220 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 132: // relational_expr: relational_expr "<=" shift_expr
#line 569 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2226 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 133: // relational_expr: relational_expr ">=" shift_expr
#line 570 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2232 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 134: // relational_expr: relational_expr "<" shift_expr
#line 571 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2238 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 135: // relational_expr: relational_expr ">" shift_expr
#line 572 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2244 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 136: // shift_expr: addi_expr
#line 576 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2250 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 137: // shift_expr: shift_expr "<<" addi_expr
#line 577 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2256 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 138: // shift_expr: shift_expr ">>" addi_expr
#line 578 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2262 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 139: // muli_expr: cast_expr
#line 582 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2268 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 140: // muli_expr: muli_expr "*" cast_expr
#line 583 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2274 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 141: // muli_expr: muli_expr "/" cast_expr
#line 584 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2280 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 142: // muli_expr: muli_expr "%" cast_expr
#line 585 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2286 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 143: // addi_expr: muli_expr
#line 589 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2292 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 144: // addi_expr: addi_expr "+" muli_expr
#line 590 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2298 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 145: // addi_expr: addi_expr "-" muli_expr
#line 591 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2304 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 146: // cast_expr: unary_expr
#line 595 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2310 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 147: // cast_expr: "(" type ")" cast_expr
#line 596 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < SizedType > (), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2316 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 148: // cast_expr: "(" "identifier" ")" cast_expr
#line 598 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[2].value.as < std::string > (), 0), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2322 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 149: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 599 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[3].value.as < std::string > (), 1), yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 2328 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 150: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 600 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[4].value.as < std::string > (), 2), yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 2334 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 151: // sizeof_expr: "sizeof" "(" type ")"
#line 604 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < SizedType > (), yylhs.location); }
#line 2340 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 152: // sizeof_expr: "sizeof" "(" expr ")"
#line 605 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 2346 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 153: // offsetof_expr: "offsetof" "(" struct_type "," external_name ")"
#line 609 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                                    { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < SizedType > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2352 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 154: // offsetof_expr: "offsetof" "(" expr "," external_name ")"
#line 611 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                                                    { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2358 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 155: // int: "-" "integer"
#line 615 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((int64_t)(~(uint64_t)(yystack_[0].value.as < int64_t > ()) + 1), yylhs.location); }
#line 2364 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 156: // int: "integer"
#line 616 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < int64_t > (), yylhs.location); }
#line 2370 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 157: // keyword: "break"
#line 620 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2376 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 158: // keyword: "config"
#line 621 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2382 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 159: // keyword: "continue"
#line 622 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2388 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 160: // keyword: "else"
#line 623 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2394 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 161: // keyword: "for"
#line 624 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2400 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 162: // keyword: "if"
#line 625 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2406 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 163: // keyword: "offsetof"
#line 626 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2412 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 164: // keyword: "return"
#line 627 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2418 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 165: // keyword: "sizeof"
#line 628 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2424 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 166: // keyword: "unroll"
#line 629 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2430 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 167: // keyword: "while"
#line 630 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2436 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 168: // ident: "identifier"
#line 634 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2442 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 169: // ident: "builtin"
#line 635 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2448 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 170: // ident: "call"
#line 636 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2454 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 171: // ident: "call_builtin"
#line 637 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2460 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 172: // ident: "stack_mode"
#line 638 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2466 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 173: // external_name: keyword
#line 642 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2472 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 174: // external_name: ident
#line 643 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2478 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 175: // call: "call" "(" ")"
#line 647 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2484 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 176: // call: "call" "(" vargs ")"
#line 648 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2490 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 177: // call: "call_builtin" "(" ")"
#line 649 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2496 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 178: // call: "call_builtin" "(" vargs ")"
#line 650 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2502 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 179: // call: "identifier" "(" ")"
#line 651 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2508 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 180: // call: "identifier" "(" vargs ")"
#line 652 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2514 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 181: // call: "builtin" "(" ")"
#line 653 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2520 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 182: // call: "builtin" "(" vargs ")"
#line 654 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2526 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 183: // call: "stack_mode" "(" ")"
#line 655 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2532 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 184: // call: "stack_mode" "(" vargs ")"
#line 656 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2538 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 185: // map: "map"
#line 660 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2544 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 186: // map: "map" "[" vargs "]"
#line 661 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2550 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 187: // var: "variable"
#line 665 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2556 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 188: // map_or_var: var
#line 669 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 2562 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 189: // map_or_var: map
#line 670 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 2568 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 190: // vargs: vargs "," expr
#line 674 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2574 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 191: // vargs: expr
#line 675 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2580 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 192: // compound_op: "<<="
#line 679 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 2586 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 193: // compound_op: "&="
#line 680 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 2592 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 194: // compound_op: "|="
#line 681 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 2598 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 195: // compound_op: "^="
#line 682 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 2604 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 196: // compound_op: "/="
#line 683 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2610 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 197: // compound_op: "-="
#line 684 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2616 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 198: // compound_op: "%="
#line 685 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2622 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 199: // compound_op: "*="
#line 686 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2628 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 200: // compound_op: "+="
#line 687 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2634 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;

  case 201: // compound_op: ">>="
#line 688 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2640 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"
    break;


#line 2644 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -257;

  const short Parser::yytable_ninf_ = -173;

  const short
  Parser::yypact_[] =
  {
     -13,   138,   -13,    27,   -49,   -13,   -13,  -257,  -257,    28,
     -22,  -257,  -257,    83,    33,  -257,    10,  -257,    45,  -257,
      82,    46,  -257,   101,  -257,  -257,  -257,  -257,  -257,   578,
     114,  -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,
    -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,   112,
     137,   135,    12,  -257,   239,   181,    86,   181,  -257,  -257,
    -257,    14,   143,    20,    24,  -257,   172,  -257,  -257,    70,
     196,   213,  -257,  -257,    17,  -257,  -257,   578,   175,  -257,
      15,   204,   188,   222,   225,   131,   180,   210,   133,     4,
    -257,  -257,  -257,  -257,     5,  -257,  -257,  -257,     7,   117,
    -257,   578,  -257,    46,   246,   248,    18,  -257,   214,  -257,
    -257,   262,    84,    47,   265,  -257,  -257,    93,  -257,  -257,
    -257,  -257,  -257,   335,   370,   416,   451,   578,   497,   274,
     532,   578,   596,   625,  -257,  -257,   578,   578,   578,   578,
     578,   578,   578,   578,   578,   578,   578,   578,   578,   578,
     578,   578,   578,   578,   578,  -257,  -257,  -257,  -257,   266,
     267,   271,   578,   272,  -257,  -257,   268,   117,   278,  -257,
    -257,  -257,  -257,  -257,   269,  -257,   178,   226,  -257,  -257,
     122,   122,   284,   230,  -257,   231,   578,    85,   578,  -257,
       3,  -257,   578,  -257,  -257,   102,  -257,   119,  -257,   127,
    -257,   206,    91,  -257,   208,    88,   290,   289,   296,   302,
    -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,  -257,
    -257,  -257,  -257,  -257,  -257,  -257,   308,   204,   188,   222,
     225,   131,   180,   180,   210,   210,   210,   210,     4,     4,
    -257,  -257,  -257,   133,   133,     1,   578,   249,  -257,   578,
    -257,  -257,   117,   578,   578,  -257,  -257,  -257,  -257,  -257,
    -257,  -257,  -257,  -257,  -257,   578,   578,   578,     9,   276,
     122,  -257,   309,  -257,   578,   312,  -257,  -257,   315,   216,
    -257,   578,  -257,  -257,  -257,  -257,  -257,  -257,  -257,   625,
     625,  -257,   578,    86,   321,   324,   325,   322,   326,  -257,
    -257,  -257,  -257,  -257,  -257,  -257,     9,  -257,  -257,   578,
    -257,  -257,  -257,   327,   336,  -257,   114,   114,   114,   578,
     114,  -257,  -257,  -257,  -257,  -257,  -257,  -257,   337,   275,
     114,     8,  -257,  -257,  -257,  -257
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       6,     0,     6,     0,    18,     6,     6,     3,     1,     0,
      44,     4,     5,     0,     0,    27,    44,    26,    46,    31,
      32,    57,    17,     0,     2,    25,    24,    29,    44,     0,
       0,    37,    41,    42,    48,    39,    40,    38,   169,   170,
     171,   168,    35,    34,    47,    36,   172,    43,    33,     0,
       0,    56,     0,    30,     0,     0,   114,     0,   111,   113,
     112,    86,   170,    87,    82,    84,   185,   187,   156,    85,
       0,     0,    89,    92,   106,    95,   146,     0,     0,   115,
     116,   118,   120,   122,   124,   126,   128,   131,   143,   136,
     139,    98,    99,    83,     0,    97,   189,   188,    90,    54,
      28,     0,    50,    57,     0,     0,     0,    22,     0,    14,
       8,     0,    82,     0,     7,    12,    13,     0,   102,   107,
     155,   103,   108,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   105,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   110,   109,   100,   101,     0,
       0,     0,    66,     0,    65,    64,     0,    54,    52,    62,
      58,    60,    59,    63,    95,    61,   189,   188,    76,    55,
       0,     0,     0,     0,    16,     0,     0,     0,     0,    15,
       0,    88,     0,   181,   191,     0,   175,     0,   177,     0,
     179,     0,     0,   183,     0,     0,     0,     0,     0,     0,
     104,   158,   166,   167,   161,   164,   162,   160,   159,   157,
     165,   163,   173,   174,    93,    94,     0,   119,   121,   123,
     125,   127,   129,   130,   132,   133,   134,   135,   137,   138,
     140,   141,   142,   144,   145,     0,     0,     0,    67,     0,
      49,    53,    54,     0,     0,   192,   201,   200,   197,   199,
     196,   198,   193,   194,   195,     0,     0,     0,     0,    23,
       0,    21,     0,   148,     0,     0,   147,    11,     0,     0,
     182,     0,   176,   178,   180,   186,   184,   151,   152,     0,
       0,    96,     0,     0,     0,     0,     0,     0,     0,    51,
      77,    78,    80,    79,    81,    20,     0,     9,   149,     0,
      10,    91,   190,     0,     0,   117,     0,     0,     0,     0,
       0,    19,   150,   153,   154,    69,    68,    70,     0,    72,
       0,     0,    71,    74,    75,    73
  };

  const short
  Parser::yypgoto_[] =
  {
    -257,  -257,   115,  -125,  -257,  -257,   218,  -257,   334,  -257,
     169,  -257,   339,  -257,   328,  -257,  -257,   -18,  -256,  -257,
    -161,   254,  -257,  -257,  -257,  -257,  -257,    29,  -257,  -257,
    -257,  -257,  -257,   -91,  -257,  -257,   -29,    66,  -257,   224,
     221,   227,   223,   228,   100,    21,   111,    96,   -70,  -257,
    -257,   120,  -257,   -19,  -130,  -257,   -90,   -94,    -3,  -108,
     187
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     4,   113,   114,   115,   116,    10,    15,   106,
     107,    16,    17,    18,    19,    20,    30,    72,   100,    22,
     166,    50,   167,   168,   169,   170,   171,   172,   335,    51,
     173,    73,    74,    75,    76,    77,   194,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,   222,    94,   224,    95,    96,    97,    98,   195,
     265
  };

  const short
  Parser::yytable_[] =
  {
      78,    48,    47,   225,   205,   177,   251,   134,   174,   176,
      24,   277,   305,    99,    99,    34,   197,   199,   201,   202,
     204,     9,   104,   123,   131,   117,   136,     8,   182,   125,
     153,   183,   155,   126,   157,    14,   118,     1,   121,   293,
     137,  -169,   154,    13,   156,    27,   158,  -171,     2,   189,
     321,  -168,   119,  -169,   122,   268,   269,   188,    28,  -171,
     325,   326,   327,  -168,   329,   132,   133,    14,    44,    68,
     175,   278,   178,   177,   332,   333,   174,   176,   105,   128,
     240,   241,   242,   163,   279,    31,    29,   189,    21,    32,
      33,   299,    23,   126,   186,   274,    34,  -172,   287,   285,
     206,   208,   209,   191,   281,    49,   192,   226,    35,  -172,
      52,  -168,   280,   223,   223,   281,   273,     7,   276,    99,
      11,    12,    36,  -168,   187,   275,    54,   101,   189,   282,
      37,    34,   281,   248,    38,    39,    40,   283,   175,   103,
     281,    41,    42,   102,    55,   306,    43,   142,   143,    44,
      45,    46,   124,   297,   120,    56,    57,    58,   177,   313,
     314,   174,   176,    59,    60,   234,   235,   236,   237,    61,
      62,    63,   108,   150,   151,   152,    64,   109,   110,   127,
     111,    65,    66,    67,    44,    68,    69,   135,   159,   160,
     161,   162,   163,   254,   164,   165,    70,    71,   144,   145,
       5,     6,   146,   147,   308,   129,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   284,   296,   286,   281,
     298,   281,   130,   175,   300,   301,   311,   294,   138,   281,
     148,   149,   139,    38,    39,    40,   302,   303,   304,   322,
      41,   266,   232,   233,   238,   239,    66,    67,    54,   180,
      46,   181,   312,    34,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   243,   244,    55,   140,   141,   185,
     223,   223,   190,   184,   250,   245,   246,    56,    57,    58,
     247,   249,   252,    54,   253,    59,    60,   270,    34,   108,
     328,    61,    62,    63,   109,   110,   105,   111,   112,   272,
     288,    55,   289,    65,    66,    67,    44,    68,    69,   290,
     291,   292,    56,    57,    58,    67,   189,   307,    70,    71,
      59,    60,   309,   310,   108,   319,    61,    62,    63,   109,
     110,   316,   111,    64,   317,   318,   320,   323,    65,    66,
      67,    44,    68,    69,    54,   193,   324,   330,   207,    34,
      25,   331,   271,    70,    71,    26,    53,   179,   315,   228,
     334,   227,    55,   230,   267,   295,   229,     0,     0,   231,
       0,     0,     0,    56,    57,    58,     0,     0,     0,    54,
     196,    59,    60,     0,    34,     0,     0,    61,    62,    63,
       0,     0,     0,     0,    64,     0,     0,    55,     0,    65,
      66,    67,    44,    68,    69,     0,     0,     0,    56,    57,
      58,     0,     0,     0,    70,    71,    59,    60,     0,     0,
       0,     0,    61,    62,    63,    54,   198,     0,     0,    64,
      34,     0,     0,     0,    65,    66,    67,    44,    68,    69,
       0,     0,     0,    55,     0,     0,     0,     0,     0,    70,
      71,     0,     0,     0,    56,    57,    58,     0,     0,     0,
      54,   200,    59,    60,     0,    34,     0,     0,    61,    62,
      63,     0,     0,     0,     0,    64,     0,     0,    55,     0,
      65,    66,    67,    44,    68,    69,     0,     0,     0,    56,
      57,    58,     0,     0,     0,    70,    71,    59,    60,     0,
       0,     0,     0,    61,    62,    63,    54,   203,     0,     0,
      64,    34,     0,     0,     0,    65,    66,    67,    44,    68,
      69,     0,     0,     0,    55,     0,     0,     0,     0,     0,
      70,    71,     0,     0,     0,    56,    57,    58,     0,     0,
       0,    54,     0,    59,    60,     0,    34,     0,     0,    61,
      62,    63,     0,     0,     0,     0,    64,     0,     0,    55,
       0,    65,    66,    67,    44,    68,    69,     0,     0,     0,
      56,    57,    58,     0,     0,     0,    70,    71,    59,    60,
       0,     0,   108,     0,    61,    62,    63,    54,     0,     0,
       0,    64,    34,     0,     0,     0,    65,    66,    67,    44,
      68,    69,     0,     0,     0,    55,     0,     0,     0,     0,
       0,    70,    71,     0,     0,     0,    56,    57,    58,     0,
       0,     0,     0,     0,    59,    60,     0,     0,     0,     0,
      61,    62,    63,     0,     0,     0,     0,    64,     0,     0,
       0,     0,    65,    66,    67,    44,    68,    69,    38,    39,
      40,     0,     0,     0,     0,    41,     0,    70,    71,     0,
       0,     0,     0,     0,   210,    46,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,    38,    39,    40,
       0,     0,     0,     0,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221
  };

  const short
  Parser::yycheck_[] =
  {
      29,    20,    20,   133,   129,    99,   167,    77,    99,    99,
       0,     8,   268,     5,     5,    14,   124,   125,   126,   127,
     128,    70,    10,     9,     7,    54,    11,     0,    10,     9,
      26,    13,    27,     9,    27,    57,    55,    50,    57,    38,
      25,    27,    38,    15,    39,     0,    39,    27,    61,    40,
     306,    27,    55,    39,    57,   180,   181,    10,    13,    39,
     316,   317,   318,    39,   320,    48,    49,    57,    67,    68,
      99,    68,   101,   167,   330,   331,   167,   167,    66,     9,
     150,   151,   152,    75,   192,     3,    41,    40,     5,     7,
       8,   252,    59,     9,    10,    10,    14,    27,    10,     8,
     129,   130,   131,    10,    13,    59,    13,   136,    26,    39,
       9,    27,    10,   132,   133,    13,   186,     2,   188,     5,
       5,     6,    40,    39,    40,    40,     9,    15,    40,    10,
      48,    14,    13,   162,    52,    53,    54,    10,   167,     4,
      13,    59,    60,     6,    27,   270,    64,    16,    17,    67,
      68,    69,     9,   247,    68,    38,    39,    40,   252,   289,
     290,   252,   252,    46,    47,   144,   145,   146,   147,    52,
      53,    54,    50,    40,    41,    42,    59,    55,    56,     7,
      58,    64,    65,    66,    67,    68,    69,    12,    71,    72,
      73,    74,    75,    15,    77,    78,    79,    80,    18,    19,
      62,    63,    22,    23,   274,     9,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    10,   246,    10,    13,
     249,    13,     9,   252,   253,   254,    10,   245,    24,    13,
      20,    21,    44,    52,    53,    54,   265,   266,   267,   309,
      59,    15,   142,   143,   148,   149,    65,    66,     9,     3,
      69,     3,   281,    14,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,   153,   154,    27,    45,    43,     7,
     289,   290,     7,    59,     6,     9,     9,    38,    39,    40,
       9,     9,     4,     9,    15,    46,    47,     3,    14,    50,
     319,    52,    53,    54,    55,    56,    66,    58,    59,    68,
      10,    27,    13,    64,    65,    66,    67,    68,    69,    13,
       8,     3,    38,    39,    40,    66,    40,     8,    79,    80,
      46,    47,    10,     8,    50,     3,    52,    53,    54,    55,
      56,    10,    58,    59,    10,    10,    10,    10,    64,    65,
      66,    67,    68,    69,     9,    10,    10,    10,   130,    14,
      16,    76,   183,    79,    80,    16,    28,   103,   292,   138,
     331,   137,    27,   140,   177,   245,   139,    -1,    -1,   141,
      -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,     9,
      10,    46,    47,    -1,    14,    -1,    -1,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    -1,    -1,    27,    -1,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    -1,    79,    80,    46,    47,    -1,    -1,
      -1,    -1,    52,    53,    54,     9,    10,    -1,    -1,    59,
      14,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,
       9,    10,    46,    47,    -1,    14,    -1,    -1,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    -1,    -1,    27,    -1,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    38,
      39,    40,    -1,    -1,    -1,    79,    80,    46,    47,    -1,
      -1,    -1,    -1,    52,    53,    54,     9,    10,    -1,    -1,
      59,    14,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,
      -1,     9,    -1,    46,    47,    -1,    14,    -1,    -1,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    -1,    -1,    27,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      38,    39,    40,    -1,    -1,    -1,    79,    80,    46,    47,
      -1,    -1,    50,    -1,    52,    53,    54,     9,    -1,    -1,
      -1,    59,    14,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80
  };

  const unsigned char
  Parser::yystos_[] =
  {
       0,    50,    61,    82,    83,    62,    63,    83,     0,    70,
      88,    83,    83,    15,    57,    89,    92,    93,    94,    95,
      96,     5,   100,    59,     0,    89,    93,     0,    13,    41,
      97,     3,     7,     8,    14,    26,    40,    48,    52,    53,
      54,    59,    60,    64,    67,    68,    69,    98,   134,    59,
     102,   110,     9,    95,     9,    27,    38,    39,    40,    46,
      47,    52,    53,    54,    59,    64,    65,    66,    68,    69,
      79,    80,    98,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   134,   136,   137,   138,   139,     5,
      99,    15,     6,     4,    10,    66,    90,    91,    50,    55,
      56,    58,    59,    84,    85,    86,    87,   117,   134,   139,
      68,   134,   139,     9,     9,     9,     9,     7,     9,     9,
       9,     7,    48,    49,   129,    12,    11,    25,    24,    44,
      45,    43,    16,    17,    18,    19,    22,    23,    20,    21,
      40,    41,    42,    26,    38,    27,    39,    27,    39,    71,
      72,    73,    74,    75,    77,    78,   101,   103,   104,   105,
     106,   107,   108,   111,   114,   117,   137,   138,   117,   102,
       3,     3,    10,    13,    59,     7,    10,    40,    10,    40,
       7,    10,    13,    10,   117,   140,    10,   140,    10,   140,
      10,   140,   140,    10,   140,    84,   117,    87,   117,   117,
      68,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,   133,   134,   135,   135,   117,   120,   121,   122,
     123,   124,   125,   125,   126,   126,   126,   126,   128,   128,
     129,   129,   129,   127,   127,     9,     9,     9,   117,     9,
       6,   101,     4,    15,    15,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,   141,    15,   141,    84,    84,
       3,    91,    68,   129,    10,    40,   129,     8,    68,   140,
      10,    13,    10,    10,    10,     8,    10,    10,    10,    13,
      13,     8,     3,    38,    98,   132,   117,   138,   117,   101,
     117,   117,   117,   117,   117,    99,    84,     8,   129,    10,
       8,    10,   117,   135,   135,   118,    10,    10,    10,     3,
      10,    99,   129,    10,    10,    99,    99,    99,   117,    99,
      10,    76,    99,    99,   108,   109
  };

  const unsigned char
  Parser::yyr1_[] =
  {
       0,    81,    82,    83,    83,    83,    83,    84,    84,    84,
      84,    84,    84,    84,    85,    86,    87,    88,    88,    89,
      89,    90,    90,    91,    92,    92,    92,    92,    93,    93,
      94,    94,    95,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    97,    97,    98,    98,    99,
     100,   101,   101,   101,   101,   102,   102,   102,   103,   103,
     103,   104,   104,   104,   105,   105,   105,   105,   106,   106,
     106,   107,   108,   108,   109,   109,   110,   111,   111,   111,
     111,   111,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   113,   113,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   114,   115,   115,   115,   115,   115,
     115,   116,   116,   116,   116,   117,   118,   118,   119,   119,
     120,   120,   121,   121,   122,   122,   123,   123,   124,   124,
     124,   125,   125,   125,   125,   125,   126,   126,   126,   127,
     127,   127,   127,   128,   128,   128,   129,   129,   129,   129,
     129,   130,   130,   131,   131,   132,   132,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   134,   134,
     134,   134,   134,   135,   135,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   137,   137,   138,   139,   139,
     140,   140,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   141
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     4,     2,     3,     3,     0,     1,     1,     4,
       4,     3,     1,     1,     1,     2,     2,     3,     0,     8,
       7,     3,     1,     3,     2,     2,     1,     1,     3,     2,
       3,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     3,     0,     1,     1,     3,
       3,     3,     1,     2,     0,     3,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     5,     5,
       5,     7,     5,     7,     1,     1,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     5,     1,     3,     3,     1,     4,     1,     1,     1,
       2,     2,     2,     2,     3,     2,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     5,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     3,     1,
       3,     3,     3,     1,     3,     3,     1,     4,     4,     5,
       6,     4,     4,     6,     6,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     4,     3,
       4,     3,     4,     3,     4,     1,     4,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"struct\"", "\"union\"", "\"builtin\"",
  "\"call\"", "\"call_builtin\"", "\"integer type\"", "\"builtin type\"",
  "\"subprog\"", "\"sized type\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "\"config\"", "\"unroll\"", "\"while\"",
  "\"for\"", "\"return\"", "\"if\"", "\"else\"", "\"continue\"",
  "\"break\"", "\"sizeof\"", "\"offsetof\"", "$accept", "program",
  "c_definitions", "type", "int_type", "pointer_type", "struct_type",
  "config", "subprog", "subprog_args", "subprog_arg",
  "probes_and_subprogs", "probe", "attach_points", "attach_point",
  "attach_point_def", "pred", "param", "block", "config_block",
  "stmt_list", "config_assign_stmt_list", "block_stmt", "expr_stmt",
  "jump_stmt", "loop_stmt", "for_stmt", "if_stmt", "block_or_if",
  "config_assign_stmt", "assign_stmt", "primary_expr", "postfix_expr",
  "tuple_access_expr", "unary_expr", "unary_op", "expr",
  "conditional_expr", "logical_or_expr", "logical_and_expr", "or_expr",
  "xor_expr", "and_expr", "equality_expr", "relational_expr", "shift_expr",
  "muli_expr", "addi_expr", "cast_expr", "sizeof_expr", "offsetof_expr",
  "int", "keyword", "ident", "external_name", "call", "map", "var",
  "map_or_var", "vargs", "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   179,   179,   185,   186,   187,   188,   192,   193,   215,
     224,   227,   230,   231,   235,   252,   255,   259,   260,   264,
     267,   273,   274,   278,   282,   283,   284,   285,   289,   299,
     312,   313,   317,   321,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   347,   351,   352,   357,   368,   372,
     375,   382,   383,   387,   388,   392,   393,   394,   398,   399,
     400,   404,   405,   410,   414,   415,   416,   417,   421,   422,
     423,   427,   431,   432,   436,   437,   441,   444,   449,   450,
     451,   456,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   483,   485,   486,   488,   490,   491,   492,   493,
     494,   495,   497,   498,   503,   509,   510,   511,   512,   514,
     515,   519,   520,   521,   522,   526,   530,   531,   536,   537,
     541,   542,   546,   547,   551,   552,   557,   558,   562,   563,
     564,   568,   569,   570,   571,   572,   576,   577,   578,   582,
     583,   584,   585,   589,   590,   591,   595,   596,   598,   599,
     600,   604,   605,   609,   611,   615,   616,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   634,   635,
     636,   637,   638,   642,   643,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   660,   661,   665,   669,   670,
     674,   675,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"
} //  bpftrace 
#line 3441 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/redhat-linux-build/parser.tab.cc"

#line 691 "/builddir/build/BUILD/bpftrace-0.21.1-build/bpftrace-0.21.1/src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
